src/Pure/build-jars
author wenzelm
Sun Jan 14 20:10:11 2018 +0100 (2018-01-14)
changeset 67433 e0c0c1f0e3e7
parent 67274 4588f714a78a
child 67438 fdb7b995974d
permissions -rwxr-xr-x
more specific tool "isabelle update_comments", for uniformity with formal comments in embedded languages;
     1 #!/usr/bin/env bash
     2 #
     3 # Author: Makarius
     4 #
     5 # build-jars - build Isabelle/Scala
     6 #
     7 # Requires proper Isabelle settings environment.
     8 
     9 ## sources
    10 
    11 declare -a SOURCES=(
    12   Admin/afp.scala
    13   Admin/build_cygwin.scala
    14   Admin/build_doc.scala
    15   Admin/build_history.scala
    16   Admin/build_jdk.scala
    17   Admin/build_log.scala
    18   Admin/build_polyml.scala
    19   Admin/build_release.scala
    20   Admin/build_status.scala
    21   Admin/check_sources.scala
    22   Admin/ci_profile.scala
    23   Admin/isabelle_cronjob.scala
    24   Admin/isabelle_devel.scala
    25   Admin/jenkins.scala
    26   Admin/news.scala
    27   Admin/other_isabelle.scala
    28   Admin/remote_dmg.scala
    29   Concurrent/consumer_thread.scala
    30   Concurrent/counter.scala
    31   Concurrent/event_timer.scala
    32   Concurrent/future.scala
    33   Concurrent/mailbox.scala
    34   Concurrent/par_list.scala
    35   Concurrent/standard_thread.scala
    36   Concurrent/synchronized.scala
    37   GUI/color_value.scala
    38   GUI/gui.scala
    39   GUI/gui_thread.scala
    40   GUI/html5_panel.scala
    41   GUI/jfx_gui.scala
    42   GUI/popup.scala
    43   GUI/wrap_panel.scala
    44   General/antiquote.scala
    45   General/bytes.scala
    46   General/codepoint.scala
    47   General/completion.scala
    48   General/date.scala
    49   General/exn.scala
    50   General/file.scala
    51   General/file_watcher.scala
    52   General/graph.scala
    53   General/graph_display.scala
    54   General/graphics_file.scala
    55   General/http.scala
    56   General/json.scala
    57   General/linear_set.scala
    58   General/logger.scala
    59   General/long_name.scala
    60   General/mercurial.scala
    61   General/multi_map.scala
    62   General/output.scala
    63   General/path.scala
    64   General/position.scala
    65   General/pretty.scala
    66   General/properties.scala
    67   General/scan.scala
    68   General/sha1.scala
    69   General/sql.scala
    70   General/ssh.scala
    71   General/symbol.scala
    72   General/time.scala
    73   General/timing.scala
    74   General/untyped.scala
    75   General/url.scala
    76   General/utf8.scala
    77   General/value.scala
    78   General/word.scala
    79   General/xz.scala
    80   Isar/document_structure.scala
    81   Isar/keyword.scala
    82   Isar/line_structure.scala
    83   Isar/outer_syntax.scala
    84   Isar/parse.scala
    85   Isar/token.scala
    86   ML/ml_console.scala
    87   ML/ml_lex.scala
    88   ML/ml_process.scala
    89   ML/ml_statistics.scala
    90   ML/ml_syntax.scala
    91   PIDE/command.scala
    92   PIDE/command_span.scala
    93   PIDE/document.scala
    94   PIDE/document_id.scala
    95   PIDE/editor.scala
    96   PIDE/line.scala
    97   PIDE/markup.scala
    98   PIDE/markup_tree.scala
    99   PIDE/protocol.scala
   100   PIDE/protocol_handlers.scala
   101   PIDE/protocol_message.scala
   102   PIDE/prover.scala
   103   PIDE/query_operation.scala
   104   PIDE/rendering.scala
   105   PIDE/resources.scala
   106   PIDE/session.scala
   107   PIDE/text.scala
   108   PIDE/xml.scala
   109   PIDE/yxml.scala
   110   ROOT.scala
   111   System/bash.scala
   112   System/command_line.scala
   113   System/cygwin.scala
   114   System/distribution.scala
   115   System/getopts.scala
   116   System/invoke_scala.scala
   117   System/isabelle_charset.scala
   118   System/isabelle_process.scala
   119   System/isabelle_system.scala
   120   System/isabelle_tool.scala
   121   System/numa.scala
   122   System/options.scala
   123   System/platform.scala
   124   System/posix_interrupt.scala
   125   System/process_result.scala
   126   System/progress.scala
   127   System/system_channel.scala
   128   Thy/bibtex.scala
   129   Thy/html.scala
   130   Thy/latex.scala
   131   Thy/present.scala
   132   Thy/sessions.scala
   133   Thy/thy_header.scala
   134   Thy/thy_resources.scala
   135   Thy/thy_syntax.scala
   136   Tools/build.scala
   137   Tools/build_docker.scala
   138   Tools/check_keywords.scala
   139   Tools/debugger.scala
   140   Tools/doc.scala
   141   Tools/imports.scala
   142   Tools/main.scala
   143   Tools/mkroot.scala
   144   Tools/print_operation.scala
   145   Tools/profiling_report.scala
   146   Tools/server.scala
   147   Tools/simplifier_trace.scala
   148   Tools/spell_checker.scala
   149   Tools/task_statistics.scala
   150   Tools/update_cartouches.scala
   151   Tools/update_comments.scala
   152   Tools/update_header.scala
   153   Tools/update_then.scala
   154   Tools/update_theorems.scala
   155   library.scala
   156   term.scala
   157   term_xml.scala
   158   ../Tools/Graphview/graph_file.scala
   159   ../Tools/Graphview/graph_panel.scala
   160   ../Tools/Graphview/graphview.scala
   161   ../Tools/Graphview/layout.scala
   162   ../Tools/Graphview/main_panel.scala
   163   ../Tools/Graphview/metrics.scala
   164   ../Tools/Graphview/model.scala
   165   ../Tools/Graphview/mutator.scala
   166   ../Tools/Graphview/mutator_dialog.scala
   167   ../Tools/Graphview/mutator_event.scala
   168   ../Tools/Graphview/popups.scala
   169   ../Tools/Graphview/shapes.scala
   170   ../Tools/Graphview/tree_panel.scala
   171   ../Tools/VSCode/src/build_vscode.scala
   172   ../Tools/VSCode/src/channel.scala
   173   ../Tools/VSCode/src/document_model.scala
   174   ../Tools/VSCode/src/dynamic_output.scala
   175   ../Tools/VSCode/src/grammar.scala
   176   ../Tools/VSCode/src/preview_panel.scala
   177   ../Tools/VSCode/src/protocol.scala
   178   ../Tools/VSCode/src/server.scala
   179   ../Tools/VSCode/src/state_panel.scala
   180   ../Tools/VSCode/src/vscode_javascript.scala
   181   ../Tools/VSCode/src/vscode_rendering.scala
   182   ../Tools/VSCode/src/vscode_resources.scala
   183   ../Tools/VSCode/src/vscode_spell_checker.scala
   184 )
   185 
   186 
   187 ## diagnostics
   188 
   189 PRG="$(basename "$0")"
   190 
   191 function usage()
   192 {
   193   echo
   194   echo "Usage: isabelle $PRG [OPTIONS]"
   195   echo
   196   echo "  Options are:"
   197   echo "    -f           fresh build"
   198   echo
   199   exit 1
   200 }
   201 
   202 function fail()
   203 {
   204   echo "$1" >&2
   205   exit 2
   206 }
   207 
   208 [ -z "$ISABELLE_HOME" ] && fail "Missing Isabelle settings environment"
   209 
   210 
   211 ## process command line
   212 
   213 # options
   214 
   215 FRESH=""
   216 
   217 while getopts "f" OPT
   218 do
   219   case "$OPT" in
   220     f)
   221       FRESH=true
   222       ;;
   223     \?)
   224       usage
   225       ;;
   226   esac
   227 done
   228 
   229 shift $(($OPTIND - 1))
   230 
   231 
   232 # args
   233 
   234 [ "$#" -ne 0 ] && usage
   235 
   236 
   237 ## build
   238 
   239 TARGET_DIR="$ISABELLE_HOME/lib/classes"
   240 TARGET="$TARGET_DIR/Pure.jar"
   241 
   242 declare -a UPDATED=()
   243 
   244 if [ -n "$FRESH" ]; then
   245   OUTDATED=true
   246 else
   247   OUTDATED=false
   248   if [ ! -e "$TARGET" ]; then
   249     OUTDATED=true
   250   else
   251     for DEP in "${SOURCES[@]}"
   252     do
   253       [ ! -e "$DEP" ] && fail "Missing file: $DEP"
   254       [ "$DEP" -nt "$TARGET" ] && {
   255         OUTDATED=true
   256         UPDATED["${#UPDATED[@]}"]="$DEP"
   257       }
   258     done
   259   fi
   260 fi
   261 
   262 if [ "$OUTDATED" = true ]
   263 then
   264   echo "### Building Isabelle/Scala ..."
   265 
   266   [ "${#UPDATED[@]}" -gt 0 ] && {
   267     echo "Changed files:"
   268     for FILE in "${UPDATED[@]}"
   269     do
   270       echo "  $FILE"
   271     done
   272   }
   273 
   274   rm -f "$TARGET"
   275   rm -rf classes && mkdir classes
   276 
   277   SCALAC_OPTIONS="$ISABELLE_SCALAC_OPTIONS -d classes"
   278 
   279   (
   280     classpath "$JAVA_HOME/lib/jfxrt.jar"
   281     classpath classes
   282     export CLASSPATH="$(platform_path "$ISABELLE_CLASSPATH")"
   283 
   284     isabelle_scala scalac $SCALAC_OPTIONS "${SOURCES[@]}" || \
   285       fail "Failed to compile sources"
   286   ) || exit "$?"
   287 
   288   mkdir -p "$TARGET_DIR" || fail "Failed to create directory $TARGET_DIR"
   289 
   290   pushd classes >/dev/null
   291 
   292   CHARSET_SERVICE="META-INF/services/java.nio.charset.spi.CharsetProvider"
   293   mkdir -p "$(dirname "$CHARSET_SERVICE")"
   294   echo isabelle.Isabelle_Charset_Provider > "$CHARSET_SERVICE"
   295 
   296   cp "$ISABELLE_HOME/lib/logo/isabelle_transparent-32.gif" isabelle/.
   297   cp "$ISABELLE_HOME/lib/logo/isabelle_transparent.gif" isabelle/.
   298 
   299   isabelle_jdk jar cfe "$(platform_path "$TARGET")" isabelle.Main META-INF isabelle || \
   300     fail "Failed to produce $TARGET"
   301 
   302   popd >/dev/null
   303 
   304   rm -rf classes
   305 fi